Quick out of the Harbour

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1441    Accepted Submission(s): 575

Problem Description
Captain Clearbeard decided to go to the harbour for a few days so his crew could inspect and repair the ship. Now, a few days later, the pirates are getting landsick(Pirates get landsick when they don't get enough of the ships' rocking motion. That's why pirates often try to simulate that motion by drinking rum.). Before all of the pirates become too sick to row the boat out of the harbour, captain Clearbeard decided to leave the harbour as quickly as possible.
Unfortunately the harbour isn't just a straight path to open sea. To protect the city from evil pirates, the entrance of the harbour is a kind of maze with drawbridges in it. Every bridge takes some time to open, so it could be faster to take a detour. Your task is to help captain Clearbeard and the fastest way out to open sea.
The pirates will row as fast as one minute per grid cell on the map. The ship can move only horizontally or vertically on the map. Making a 90 degree turn does not take any extra time.

Input
The first line of the input contains a single number: the number of test cases to follow. Each test case has the following format:
1. One line with three integers, h, w (3 <= h;w <= 500), and d (0 <= d <= 50), the height and width of the map and the delay for opening a bridge.
2.h lines with w characters: the description of the map. The map is described using the following characters:
—"S", the starting position of the ship.
—".", water.
—"#", land.
—"@", a drawbridge.
Each harbour is completely surrounded with land, with exception of the single entrance.

Output
For every test case in the input, the output should contain one integer on a single line: the travelling time of the fastest route to open sea. There is always a route to open sea. Note that the open sea is not shown on the map, so you need to move outside of the map to reach open sea.

Sample Input
2
6 5 7
#####
#S..#
#@#.#
#...#
#@###
#.###
4 5 3
#####
#S#.#
#@..#
###@#

Sample Output
16
11

这个题大概的意思就是一艘船要从S点出发,到达唯一出口的最短时间,只能走'.'(有水的地方)或者'@'标记的地方,不能走'#'标记的地方,因为有'.'花费的时间为1,'@'花费的时间为第三个参数c+1,所以考虑优先队列。

下面是暑假培训c++代码:

#include<iostream>
#include<cstdio>
#include<queue>
#include<string.h>
using namespace std;
char mp[502][502];
int vis[502][502];
int dir[][2]= {{1,0},{-1,0},{0,1},{0,-1}};
int n,m,c,ex,ey;
struct node
{
int x,y,step;
};
bool operator < (node t1,node t2)
{
return t1.step>t2.step;
}
priority_queue<node>q;
int bfs()
{
node t,next;
int tx;
while(!q.empty())
{
t=q.top();
q.pop();
if(t.x==ex&&t.y==ey) return t.step;
for(int i=0; i<4; i++)
{
next.step=t.step;
next.x=t.x+dir[i][0];
next.y=t.y+dir[i][1];
if(next.x<0||next.x>=n||next.y<0||next.y>=m||vis[next.x][next.y]||mp[next.x][next.y]=='#')
continue;
if(mp[next.x][next.y]=='@')
next.step+=(c+1);
if(mp[next.x][next.y]=='.')
next.step++;
vis[next.x][next.y]=1;
q.push(next);
}
}
return 0; }
int main()
{
int tcase;
scanf("%d",&tcase);
while(tcase--)
{
node t;
memset(mp,0,sizeof(mp));
memset(vis,0,sizeof(vis));
while(!q.empty()) q.pop();
scanf("%d%d%d",&n,&m,&c);
for(int i=0; i<n; i++)
{
scanf("%s",mp[i]);
for(int j=0; j<m; j++)
{
if(mp[i][j]=='S')
{
t.x=i,t.y=j,t.step=0;
}
if((i==0||i==n-1||j==0||j==m-1)&&mp[i][j]!='#')
{
ex=i,ey=j;
}
}
}
q.push(t);
vis[t.x][t.y]=1;
printf("%d\n",bfs()+1);
}
return 0;
}

  这里是最近写的JAVA代码(弄了好久,也积累了许多,发现class 和struct 不是一个东西,后面贴了个问题代码,有兴趣的朋友可以断点调试下,你会发现一个神奇的事情,也许是我觉得神奇吧,哈哈)有兴趣用JAVA写这种代码的人很少吧,我在网上搜都是用的c++,我就第一个吃螃蟹的人,也为以后需要的朋友提供个借鉴:

import java.util.PriorityQueue;
import java.util.Scanner; public class Main {
static class node implements Comparable<node>{
int x, y, step;
public node(){ }
public node(int x,int y,int step){
this.x=x;
this.y=y;
this.step=step;
}
@Override
public int compareTo(node o) {
if(this.step>o.step) return 1;
return -1;
}
} static int n, m, value;
static int startx, starty, endx, endy;
static char[][] map;
static boolean[][] visit;
static int dir[][] = { { 1, 0 }, { -1, 0 }, { 0, 1 }, { 0, -1 } }; public static void main(String[] args) {
Scanner sc = new Scanner(System.in);
int tcase = sc.nextInt();
while (tcase-- > 0) {
n = sc.nextInt();
m = sc.nextInt();
value = sc.nextInt();
map = new char[n][m];
visit = new boolean[n][m];
for (int i = 0; i < n; i++) {
String str = sc.next();
map[i] = str.toCharArray();
for (int j = 0; j < m; j++) {
if (map[i][j] == 'S') {
startx = i;
starty = j;
}
if (map[i][j] != '#'
&& (i == 0 || i == n - 1 || j == 0 || j == m - 1)) {
endx = i;
endy = j;
}
}
}
System.out.println(BFS(startx,starty));
} } private static int BFS(int startx2, int starty2) {
PriorityQueue<node> q =new PriorityQueue<node>();
node t = new node(startx2,starty2,1); //step初始值为1,S点也要算进去
q.add(t);
visit[t.x][t.y]=true;
while(!q.isEmpty()){
t = q.remove();
if(t.x==endx&&t.y==endy) {
return t.step;
}
for(int i=0;i<4;i++){
int step = t.step;
int x = t.x+dir[i][0];
int y = t.y+dir[i][1];
if(x<0||x>n-1||y<0||y>m-1||visit[x][y]||map[x][y]=='#') continue;
if(map[x][y]=='@'){
step+=(value+1);
}
if(map[x][y]=='.'){
step++;
}
visit[x][y]=true;
q.add(new node(x,y,step));
}
}
return 0;
}
}

问题代码:

//问题代码
import java.util.PriorityQueue;
import java.util.Scanner; public class Main {
static class node implements Comparable<node>{
int x, y, step;
@Override
public int compareTo(node o) {
if(this.step>o.step) return 1;
return -1;
}
} static int n, m, value;
static int startx, starty, endx, endy;
static int[][] map;
static boolean[][] visit;
static int dir[][] = { { 1, 0 }, { -1, 0 }, { 0, 1 }, { 0, -1 } }; public static void main(String[] args) {
Scanner sc = new Scanner(System.in);
int tcase = sc.nextInt();
while (tcase-- > 0) {
n = sc.nextInt();
m = sc.nextInt();
value = sc.nextInt();
map = new int[n][m];
visit = new boolean[n][m];
for (int i = 0; i < n; i++) {
String str = sc.next();
char[] x = str.toCharArray();
for (int j = 0; j < m; j++) {
if (x[j] == 'S') {
startx = i;
starty = j;
map[i][j] = 1;
}
if (x[j] == '@') {
map[i][j] = value+ 1;
}
if (x[j] == '#') {
map[i][j] = -1;
}
if (x[j] == '.') {
map[i][j] = 1;
}
if (x[j] != '#'
&& (i == 0 || i == n - 1 || j == 0 || j == m - 1)) {
endx = i;
endy = j;
map[i][j] = 0;
}
}
}
System.out.println(BFS(startx,starty));
} } private static int BFS(int startx2, int starty2) {
PriorityQueue<node> q =new PriorityQueue<node>();
node t = new node();
t.x=startx;
t.y=starty;
t.step = 0;
q.add(t);
visit[t.x][t.y]=true;
while(!q.isEmpty()){
t = q.remove();
//System.out.println(t.x+" "+t.y+" "+t.step);
if(t.x==endx&&t.y==endy) {
return t.step;
}
node t1 = new node();
for(int i=0;i<4;i++){
t1.step = t.step;
t1.x = t.x+dir[i][0];
t1.y = t.y+dir[i][1];
if(t1.x<0||t1.x>n-1||t1.y<0||t1.y>m-1||visit[t1.x][t1.y]||map[t1.x][t1.y]==-1) continue;
t1.step +=map[t1.x][t1.y];
//System.out.println("t1:"+t1.x+" "+t1.y+" "+t1.step);
visit[t1.x][t1.y]=true;
q.add(t1);
//System.out.println(q.peek().x+" "+q.peek().y+" "+q.peek().step);
}
}
return 0;
}
}

  

hdu 4198:Quick out of the Harbour解题报告的更多相关文章

  1. hdu 4198 Quick out of the Harbour

    题目连接 http://acm.hdu.edu.cn/showproblem.php?pid=4198 Quick out of the Harbour Description Captain Cle ...

  2. HDU - 4198 Quick out of the Harbour (BFS+优先队列)

    Description Captain Clearbeard decided to go to the harbour for a few days so his crew could inspect ...

  3. hdu 4198 Quick out of the Harbour(BFS+优先队列)

    题目链接:hdu4198 题目大意:求起点S到出口的最短花费,其中#为障碍物,无法通过,‘.’的花费为1 ,@的花费为d+1. 需注意起点S可能就是出口,因为没考虑到这个,导致WA很多次....... ...

  4. ACM:HDU 2199 Can you solve this equation? 解题报告 -二分、三分

    Can you solve this equation? Time Limit: / MS (Java/Others) Memory Limit: / K (Java/Others) Total Su ...

  5. HDU 4303 Hourai Jeweled 解题报告

    HDU 4303 Hourai Jeweled 解题报告 评测地址: http://acm.hdu.edu.cn/showproblem.php?pid=4303 评测地址: https://xoj. ...

  6. 【解题报告】 Leapin' Lizards HDU 2732 网络流

    [解题报告] Leapin' Lizards HDU 2732 网络流 题外话 在正式讲这个题目之前我想先说几件事 1. 如果大家要做网络流的题目,我在网上看到一个家伙,他那里列出了一堆网络流的题目, ...

  7. HDU 4869 Turn the pokers (2014多校联合训练第一场1009) 解题报告(维护区间 + 组合数)

    Turn the pokers Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) ...

  8. 2014 ACM/ICPC 鞍山赛区现场赛 D&amp;I 解题报告

    鞍山现场赛结束了呢-- 我们出的是D+E+I三道题-- 吾辈AC掉的是D和I两道,趁着还记得.先在这里写一写我写的两道水题D&I的解题报告吧^_^. D题的意思呢是说星云内有一堆排成一条直线的 ...

  9. 【百度之星2014~初赛(第二轮)解题报告】Chess

    声明 笔者近期意外的发现 笔者的个人站点http://tiankonguse.com/ 的非常多文章被其他站点转载.可是转载时未声明文章来源或參考自 http://tiankonguse.com/ 站 ...

随机推荐

  1. android getpost代码

    GetPostUtil public class GetPostUtil { /** * 向指定URL发送GET方法的请求 * * @param url * 发送请求的URL * @param par ...

  2. 读取proc/uptime信息。

    #include <stdio.h> #include<unistd.h> #include<sys/types.h> #include<sys/stat.h ...

  3. linux 常见服务端口

    Linux服务器在启动时需要启动很多系统服务,它们向本地和网络用户提供了Linux的系统功能接口,直接面向应用程序和用户.提供这些服务的程序是由运行在后台的守护进程(daemons) 来执行的.守护进 ...

  4. solr单元测试

    package com.taotao.rest.solr; import java.io.IOException; import org.apache.solr.client.solrj.SolrQu ...

  5. 在eclipse中安装html编辑器插件

    1.下载插件( 点击下载)                 解压后得到GEF-ALL-3.4.1.zip和tk.eclipse.plugin.htmleditor_2.2.0.jar   2.安装GE ...

  6. Naive Operations HDU多校(线段树上线段果)

    Problem Description In a galaxy far, far away, there are two integer sequence a and b of length n.b ...

  7. github上面创建文件夹

  8. JS this的指向

    总结:this指向调用函数的那个对象. 在不同的应用场景this的指向有所不同,但细细思考都符合总结的意思. 场景一:一般的函数调用 这种常见的函数调用方式this指向的是window,因为相当于是w ...

  9. LightOJ 1278 - Sum of Consecutive Integers 分解奇因子 + 思维

    http://www.lightoj.com/volume_showproblem.php?problem=1278 题意:问一个数n能表示成几种连续整数相加的形式 如6=1+2+3,1种. 思路:先 ...

  10. 从零开始开发一款app,所想到的

    我在知乎上看到这个问题http://www.zhihu.com/question/27645587.我在阅读了各位大牛的答案后,再加上自己的思考,就有了这篇文章的内容.     从零开始开发一款app ...